package com.malk.kuaikeli;

import cn.hutool.core.util.NumberUtil;
import cn.hutool.core.util.RandomUtil;
import com.alibaba.fastjson.JSONObject;
import com.malk.kuaikeli.service.KKLService;
import com.malk.kuaikeli.service.SupplierMaterialService;
import com.malk.server.aliwork.YDConf;
import com.malk.server.aliwork.YDParam;
import com.malk.service.aliwork.YDClient;
import com.malk.utils.UtilMap;
import lombok.extern.slf4j.Slf4j;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.junit4.SpringRunner;

import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Slf4j
@SpringBootTest
@RunWith(SpringRunner.class)
public class DdTest {

    @Autowired
    private SupplierMaterialService supplierMaterialService;
    @Autowired
    private YDClient ydClient;

    @Test
    public void create() {
        supplierMaterialService.sync();
//        supplierMaterialService.syncPrice();
    }

    @Test
    public void kk(){
        String fid="FINST-W9D66Q61MLZKG5LAEDWCBBS61E1D3FQFYS1WLJWL";
        Map formData=(Map) ydClient.queryData(YDParam.builder().formInstId(fid).build(), YDConf.FORM_QUERY.retrieve_id).getFormData();
        Map addMap=new HashMap();
        String data=String.valueOf(formData.get("associationFormField_lln477nb_id"));
        System.out.println(data.substring(1,data.length()-1).replaceAll("\\\\",""));
        addMap.put("associationFormField_llndtdwg",JSONObject.parseArray(data.substring(1,data.length()-1).replaceAll("\\\\","")));// 项目点
        ydClient.operateData(YDParam.builder().formUuid("FORM-RK966E71T0LDSTW39WFHE9OQ5GU23FKRRDNLL2").formDataJson(JSONObject.toJSONString(addMap)).build(), YDConf.FORM_OPERATION.create);
    }

    String data="{\"name\":\"XM-20240508-017\",\"area\":\"晚餐\",\"list\":[{\"numberField_lln477o2\":30000,\"numberField_lmym5628\":30,\"textField_llndm599\":\"净菜-杏鲍菇片\",\"textField_lln3lmn2\":\"KG\",\"textField_lm4m83rv\":\"块\",\"textField_lmk97m1v\":\"XKLNY00206\",\"selectField_lmqclyx9\":\"蔬菜类\",\"numberField_lmqclyxa\":8.64,\"numberField_lmsvfftq\":6.4,\"numberField_lmsvfftr\":35,\"numberField_lnrzzg03\":\"\",\"textField_lnrzzg04\":\"\",\"textField_lnwxz9ji\":\"\",\"numberField_lns0dkzv\":0,\"numberField_lomyf89l\":30,\"textField_lptgvips\":\"KG\",\"radioField_ln1ez5le\":\"否\",\"dateField_ln1ez5lg\":1717171200000,\"textField_ln1ez5li\":\"20240601\",\"dateField_lqg8oid5\":1717171200000,\"numberField_lqg8oid6\":0,\"textField_lnwktyzy\":\"已启用\"},{\"numberField_lln477o2\":30000,\"numberField_lmym5628\":30,\"textField_llndm599\":\"蟹味菇（散装）\",\"textField_lln3lmn2\":\"KG\",\"textField_lm4m83rv\":\"块\",\"textField_lmk97m1v\":\"XKLNY00208\",\"selectField_lmqclyx9\":\"蔬菜类\",\"numberField_lmqclyxa\":11.88,\"numberField_lmsvfftq\":8.8,\"numberField_lmsvfftr\":35,\"numberField_lnrzzg03\":\"\",\"textField_lnrzzg04\":\"\",\"textField_lnwxz9ji\":\"\",\"numberField_lns0dkzv\":0,\"numberField_lomyf89l\":30,\"textField_lptgvips\":\"KG\",\"radioField_ln1ez5le\":\"否\",\"dateField_ln1ez5lg\":1717171200000,\"textField_ln1ez5li\":\"20240601\",\"dateField_lqg8oid5\":1717171200000,\"numberField_lqg8oid6\":0,\"textField_lnwktyzy\":\"已启用\"}],\"form\":{\"employeeField_lln477n4\":[\"01431926295320086679\"],\"dateField_lln477n5\":1717149266262,\"associationFormField_lln477nb\":[{\"formType\":\"receipt\",\"formUuid\":\"FORM-MP966K81PGGD51ZUEU29Q6YVKSOE3SDK29KLL9\",\"instanceId\":\"FINST-ZNC669D1RNXK287Q7L0L2DNVSB1S3MOT5FXVLJS1\",\"subTitle\":\"\",\"appType\":\"APP_OHSG8KMIP9SGXV32XUQJ\",\"title\":\"联发芯项目2\"}],\"cascadeDateField_lm60c4ai\":[1717171200000,1717171200000],\"textField_lln477nh\":\"XM-20240508-017\",\"tableField_lqvd1r28\":[{\"dateField_lqvd4nej\":1717171200000,\"radioField_lqvd4nel\":\"零点菜单\",\"numberField_lm8z1xvk\":720,\"numberField_lm8z1xun\":7200,\"numberField_lm8z1xup\":615.6,\"numberField_lm8z1xur\":18.55,\"numberField_lm8z1xut\":600}],\"tableField_lln477nv\":[{\"associationFormField_lln477nx\":[{\"appType\":\"APP_OHSG8KMIP9SGXV32XUQJ\",\"formType\":\"receipt\",\"formUuid\":\"FORM-IH966T61XJZDNT4D9N6D189RJ2CK3Q27NZ5ML0\",\"instanceId\":\"FINST-DOC66I91SYJLOVEC63N8CCV0H7HD30Z75HUWLI9D\",\"title\":\"CDJH-20240531-077\"}],\"checkboxField_lm5zvhvi\":[\"零点菜单\"],\"selectField_llm1i9yl\":\"晚餐\",\"dateField_lm8zj9hi\":1717171200000,\"textField_lm8zj9hl\":\"CDJH-20240531-077\",\"textField_lpjet322\":\"大餐\"}],\"employeeField_lvc045f6\":[\"2635346051858627\"],\"employeeField_lviynmia\":[\"4813133263949603\"],\"employeeField_lviynmib\":[\"0438200920569130\"]},\"user\":\"01431926295320086679\",\"poid\":\"FINST-DOC66I91SYJLOVEC63N8CCV0H7HD30Z75HUWLI9D\"}";

    @Autowired
    private KKLService kklService;

    @Test
    public void test(){
        kklService.validateApprove(JSONObject.parseObject(data));
        List<Map> table=null;
        String formUuid="FORM-XHA66881J8KDA6V3FM6LZBUP9PDE37VESDNLL6";
//        Map formData=(Map) ydClient.queryData(YDParam.builder().formInstId(fid).build(), YDConf.FORM_QUERY.retrieve_id).getFormData();
//        List<Map> list=UtilMap.getList(formData,"tableField_lln477nw");
//        saveData(list,formData,formUuid,false);// -
//        saveData(table,formData,formUuid,true);// +
    }

    private void saveData(List<Map> list,Map formData,String formUuid,boolean isAdd){
        for(Map map:list){
            Map queryMap=new HashMap();
            queryMap.put("dateField_llndtdwl", Arrays.asList(map.get("dateField_ln1ez5lg"),map.get("dateField_ln1ez5lg")));// 日期
            queryMap.put("textField_llq9x6ov",formData.get("textField_lln477nh"));// 项目编号
            queryMap.put("textField_lmk97m1v",formData.get("textField_lmk97m1v"));// 档口编号
            Map upMap=new HashMap();
            upMap.put("numberField_llojyfy3",map.get("numberField_lmsvfftq"));// 成本单价
            upMap.put("numberField_llojyfy4",map.get("numberField_lmsvfftr"));// 服务费率
            upMap.put("dateField_llndtdwl",map.get("dateField_ln1ez5lg"));// 计划日期
            upMap.put("textField_llndm599",map.get("textField_llndm599"));// 原材料名称
            upMap.put("textField_lluj4hu1",map.get("textField_lln3lmn2"));// 单位
            upMap.put("textField_llq9x6ov",formData.get("textField_lln477nh"));// 项目编号
            upMap.put("textField_lm5z7kvo",map.get("textField_ln1ez5li"));// 计划日期（文本）
            upMap.put("textField_lm5z4ioi",formData.get("textField_lmsvfftp"));// 项目名称
            upMap.put("textField_lmk97m1v",map.get("textField_lmk97m1v"));// 原材料编号
            upMap.put("selectField_lmqclyx9",map.get("selectField_lmqclyx9"));// 第一分类
            upMap.put("numberField_lmqclyxa",map.get("numberField_lmqclyxa"));// 供货价
            upMap.put("textField_lnsmha2j",map.get("textField_lnwxz9ji"));// 品牌
            upMap.put("textField_lpjet322",formData.get("textField_lpjet322"));// 档口名称
            upMap.put("textField_lpjet321",formData.get("textField_lpjet321"));// 档口编号
            List<Map> list2=(List<Map>) ydClient.queryData(YDParam.builder().formUuid(formUuid).searchFieldJson(JSONObject.toJSONString(queryMap)).build(), YDConf.FORM_QUERY.retrieve_list).getData();
            if(list2==null||list2.size()<1){
                if(!isAdd){
                    log.info("未找到对应的计划采购单,退出");
                    continue;
                }
                upMap.put("numberField_lln477o2", map.get("numberField_lmym5628"));// 初始采购数量（kg）
                upMap.put("numberField_lm9008fq", map.get("numberField_lmym5628"));// 实际采购数量（kg）
                upMap.put("numberField_lns0dkzv", map.get("numberField_lns0dkzv"));// 投料数量（kg）
                ydClient.operateData(YDParam.builder().formUuid(formUuid).formDataJson(JSONObject.toJSONString(upMap)).build(), YDConf.FORM_OPERATION.create);
            }else{
                Map oldMap=UtilMap.getMap(list2.get(0),"formData");
                if(isAdd){
                    upMap.put("numberField_lln477o2", NumberUtil.add(UtilMap.getString(oldMap,"numberField_lln477o2"),UtilMap.getString(map,"numberField_lmym5628")));// 初始采购数量（kg）
                    upMap.put("numberField_lm9008fq", NumberUtil.add(UtilMap.getString(oldMap,("numberField_lm9008fq")),UtilMap.getString(map,("numberField_lmym5628"))));// 实际采购数量（kg）
                    upMap.put("numberField_lns0dkzv", NumberUtil.add(UtilMap.getString(oldMap,("numberField_lns0dkzv")),UtilMap.getString(map,("numberField_lns0dkzv"))));// 投料数量
                }else {
                    upMap.put("numberField_lln477o2", NumberUtil.sub(UtilMap.getString(oldMap, "numberField_lln477o2"), UtilMap.getString(map, "numberField_lmym5628")));// 初始采购数量（kg）
                    upMap.put("numberField_lm9008fq", NumberUtil.sub(UtilMap.getString(oldMap, ("numberField_lm9008fq")), UtilMap.getString(map, ("numberField_lmym5628"))));// 实际采购数量（kg）
                    upMap.put("numberField_lns0dkzv", NumberUtil.sub(UtilMap.getString(oldMap, ("numberField_lns0dkzv")), UtilMap.getString(map, ("numberField_lns0dkzv"))));// 投料数量
                }
                ydClient.operateData(YDParam.builder().formInstanceId(UtilMap.getString(list2.get(0),"formInstanceId")).updateFormDataJson(JSONObject.toJSONString(upMap)).build(), YDConf.FORM_OPERATION.update);
            }
        }
    }
}
